from numpy.random import RandomState
from pycompss.api.api import compss_wait_on
import numpy as np
import dislib as ds
from dislib.trees import RandomForestClassifier
from sklearn.datasets import make_classification
from sklearn.metrics import accuracy_score
from sklearn.model_selection import train_test_split
import time


def main():
    x, y = make_classification(
        n_samples=1000000,
        n_features=100,
        n_classes=2,
        n_informative=42,
        n_redundant=38,
        n_repeated=20,
        n_clusters_per_class=2,
        shuffle=True,
        random_state=0,
    )
    x_train = x[:900000, :]
    x_test = x[900000:, :]
    y_train = y[:900000]
    y_test = y[900000:]
    x = ds.array(x_train, (450000, x.shape[1]))
    y = ds.array(y_train, (450000, 1))
    x_test = ds.array(x_test, (50000, x.shape[1]))
    y_test = ds.array(y_test, (50000, 1))
    random_state = RandomState(0)
    rf = RandomForestClassifier(n_estimators=3, try_features=2, distr_depth=1, n_classes=2, mmap=False, random_state=random_state)
    start_time = time.time()
    rf.fit(x, y)
    print("Training time:" + str(time.time() - start_time))
    print("Score obtained in test:"+str(rf.score(x_test, y_test, collect=True)))


if __name__ == "__main__":
    main()
